﻿using System;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WebForms;

namespace _9538
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                InMemoryFeatureLayer mapSubShapeLayer = new InMemoryFeatureLayer();
                mapSubShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.StandardColors.Black), 5);
                TextStyle pttext = new TextStyle("label", new GeoFont("Arial", 8, DrawingFontStyles.Bold), new GeoSolidBrush(GeoColor.FromArgb(255, 0, 0, 0)));
                pttext.XOffsetInPixel = 10;
                pttext.DuplicateRule = LabelDuplicateRule.NoDuplicateLabels;
                pttext.BestPlacement = true;
                mapSubShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = pttext;
                mapSubShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                Collection<Vertex> points = new Collection<Vertex>();
                points.Add(new Vertex(10, 10));
                points.Add(new Vertex(20, 5));
                points.Add(new Vertex(-5, -8));
                points.Add(new Vertex(15, -3));
                points.Add(new Vertex(-12, 25));

                for (int i = 0; i < points.Count; i++)
                {
                    int pn = i + 1;
                    string pointName = "P" + pn;
                    Feature f = new Feature(new PointShape(points[i].X, points[i].Y, 0.0000));
                    f.ColumnValues.Add("label", pointName);
                    mapSubShapeLayer.InternalFeatures.Add("LT" + i, f);
                }

                LayerOverlay overlay = new LayerOverlay();
                overlay.Layers.Add("InMemoryFeatureLayer", mapSubShapeLayer);

                Map1.CustomOverlays.Add(overlay);

                mapSubShapeLayer.Open();
                Map1.CurrentExtent = mapSubShapeLayer.GetBoundingBox();                            
            }
        }
    }
}